; _GetCHR      fetches from a display page a 8x8 char bitmap for char n
; _PutString   prints an asciiz string
; _PutHex      prints the value of a 32bit word as an 8 digit hex number
;              n.b. Using BCDs you can print decimal values
; _CHRFNT    Pointer to the current 8kbyte character bitmap pool
;            YOU must initialize it before using the chario functions!!!!

extrn _CHRFNT:DWORD
      ; pointer to the current character bitmap buffer
      ; (a block of 8Kbytes containing the bitmaps the 128 ascii chars)
      
extrn _GetCHR:near
         ; fetches from RAM VIDEO to the current character buffer
         ; (referenced by _CHRFNT)
         ; an 8x8 bitmap that will be used for character with index n
         ; VALID INDEXES ARE 0..127 !!
         ; esi = screen base offset
         ; edi = character n bitmap index
         ; eax = x position in pixels
         ; edx = y position in pixels

extrn _PutString:near
         ; edi = screen base
         ; eax = x in pixels
         ; edx = y in pixels
         ; ebx = stringz

extrn _PutHex: near
         ; scrive il numero BCD a 32 bit
         ; contenuto in ebx
         ; edi = screen dest
         ; eax = x in pixels
         ; edx = y in pixels
         ; ebx = number to write
         
extrn _GetString: near
        ; edi= scr dest
        ; eax= x in pixels
        ; edx= y in pixels
        ; ecx= max. string size
        ; ebx= stringz (gets automatically truncated to NUL on entry)
        ;      must point to a sequence of at least ecx+1 bytes

